package atVM;

import java.util.HashMap;
import java.util.UUID;

import mobileAgent.GeneralMobileAgent;
import residenceAgent.ResidenceAgent;
import util.io.FileReader;
import edu.vub.at.IAT;
import edu.vub.at.exceptions.InterpreterException;

public class AFrame {
	protected static final String _ENV_AT_INIT_ = "AT_INIT";
	private static final String _ENV_AT_LIBPATH_ = "AT_LIBPATH";
	private IAT iat;
	private ResidenceAgent residenceAgent;
	HashMap<String, GeneralMobileAgent> mobileAgentList = new HashMap<String, GeneralMobileAgent>();

	public AFrame(IAT iat) {
		this.iat = iat;
		String lines = FileReader
				.readFile(Constant.frameInitFileLocation, "\n");
		iat.evalAndPrint(lines);
		residenceAgent = new ResidenceAgent(iat);
	}

	public AFrame(String[] args) {
		System.setProperty(_ENV_AT_INIT_, Constant.initFileLocation);
		System.setProperty(_ENV_AT_LIBPATH_, "at=" + Constant.atLibLocation
				+ "/at;applications=" + Constant.atLibLocation
				+ "/applications;bridges=" + Constant.atLibLocation
				+ "/bridges;frameworks=" + Constant.atLibLocation
				+ "/frameworks;demo=" + Constant.atLibLocation + "/demo;test="
				+ Constant.atLibLocation + "/test;extensions="
				+ Constant.atLibLocation + "/extensions;aframe="
				+ Constant.atLibLocation + "/aframe");
		try {
			iat = new IAT(args);
		} catch (InterpreterException e) {
			e.printStackTrace();
		}
		String lines = FileReader
				.readFile(Constant.frameInitFileLocation, "\n");
		iat.evalAndPrint(lines);
		residenceAgent = new ResidenceAgent(iat);
	}

	public IAT getVM() {
		return iat;
	}

	public ResidenceAgent getResidenceAgent() {
		return residenceAgent;
	}

	public HashMap<String, GeneralMobileAgent> getMobileAgentList() {
		return mobileAgentList;
	}

	public GeneralMobileAgent createMobileAgent() {
		GeneralMobileAgent mobileAgent = new GeneralMobileAgent(iat);
		String maID = UUID.randomUUID().toString().replace("-", "");
		iat.evalAndPrint("def ma" + maID
				+ " := /.aframe.generalMobileAgent.new();\n" + "ma" + maID
				+ ".setId(\"" + maID + "\");", System.out);

		mobileAgent.setId(maID);
		iat.evalAndPrint("ma" + maID + ".setResidenceAgent(residenceAgent);",
				System.out);
		mobileAgentList.put(mobileAgent.getId(), mobileAgent);
		return mobileAgent;
	}
}
