package edu.vub.at.android.interpreter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import twitter4j.Query;
import twitter4j.Tweet;
import twitter4j.Twitter;
import twitter4j.TwitterException;
import twitter4j.TwitterFactory;
import android.app.ListActivity;
import android.app.ProgressDialog;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.widget.SimpleAdapter;
import android.widget.Toast;

public class TweetsSearchActivity extends ListActivity {

	public class FetchTweetsTask extends AsyncTask<Void, Void, List<Tweet>> {

		private ProgressDialog pd;

		@Override
		protected void onPreExecute() {
			pd = new ProgressDialog(TweetsSearchActivity.this);
			pd.setTitle("Loading AmbientTalk tweets");
			pd.setMessage("Please wait..");
			pd.show();
		}

		@Override
		protected List<Tweet> doInBackground( Void... params) {
			Twitter twitter = new TwitterFactory().getInstance();
			try {
				Query query = new Query("AmbientTalk");
				query.setRpp(10);
				return twitter.search(query).getTweets();
			} catch (TwitterException e) {
				Log.e("AmbientTalk", "Could not fetch tweets", e);
				return null;
			}
		}

		@Override
		protected void onPostExecute(List<Tweet> tweets) {
			pd.dismiss();

			if (tweets == null) {
				Toast.makeText(TweetsSearchActivity.this, "Could not load tweets.", Toast.LENGTH_SHORT).show();
				finish();
				return;
			}
			
			ArrayList<HashMap<String,String>> listData = new ArrayList<HashMap<String,String>>();

			for (Tweet tweet : tweets) {	
				HashMap<String, String> hm = new HashMap<String, String>();
				hm.put("from", tweet.getFromUser().toString());
				hm.put("to", tweet.getText() );
				listData.add(hm);
			}

			setListAdapter(new SimpleAdapter(TweetsSearchActivity.this, listData,
					android.R.layout.simple_list_item_2,
					new String[] { "from", "to" },
					new int[] { android.R.id.text1, android.R.id.text2 }));
		}
	}

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		new FetchTweetsTask().execute();
		
		List<Map<String, String>> listData = new ArrayList<Map<String, String>>();
		HashMap<String, String> hm = new HashMap<String, String>();
		hm.put("from", "No tweets found");
		hm.put("to", "No tweets found");
		listData.add(hm);
//		
//		setListAdapter(new SimpleAdapter(TweetsSearchActivity.this, listData,
//				android.R.layout.simple_list_item_2,
//				new String[] { "from", "to" },
//				new int[] { android.R.id.text1, android.R.id.text2 }));
	}
}
