/**
 * AmbientTalk/2 Project
 * (c) Programming Technology Lab, 2006 - 2009
 * Authors: Software Languages Lab - Ambient Group
 * 
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */
package edu.vub.at.android.util;

import java.io.ByteArrayOutputStream;
import java.io.PrintStream;

import android.os.Handler;
import android.os.Message;

public class OutputAT extends PrintStream {

	private ByteArrayOutputStream outMem_;
	private int code_;
	private Handler target_;

	public static OutputAT in  = new OutputAT(IntConstants._ANDROID_INPUT_);
	public static OutputAT out = new OutputAT(IntConstants._ANDROID_OUTPUT_);
	public static OutputAT err = new OutputAT(IntConstants._ANDROID_ERROR_);
	
	private OutputAT(int code, ByteArrayOutputStream out) {
		super(out, true);
		this.code_ = code;
		this.outMem_ = out;
	}
	
	public OutputAT(int code) {
		this(code, new ByteArrayOutputStream(4096));
	}

	@Override
	public void flush() {
		if (target_ == null)
			return;
		
		Message m = new Message();
		
		m.what = code_;
		m.obj = outMem_.toString();
		target_.sendMessage(m);
		
		outMem_.reset();
	}
	
	public void attach(Handler newTarget) {
		target_ = newTarget;
		flush();
	}

	public void detach() {
		target_ = null;
	}

}